/**
 * @file kdp_crc.h
 * 
 * @brief Kneron crc driver header
 *
 * Copyright (C) 2018 Kneron, Inc. All rights reserved.
 *
 */
#ifndef __KDP_CRC16_H__
#define __KDP_CRC16_H__

#include "base.h"

#define CRC16_CONSTANT 0x8005
#define ENABLE_CRC32 0

/**
 * @brief generate crc16 code
 * @parem [in] data
 * @parem [in] size : data size
 */
uint16_t kdp_gen_crc16(uint8_t *data, uint32_t size);
uint32_t kdp_gen_sha32(uint8_t *data, uint32_t size);
uint32_t kdp_gen_sum32(uint8_t *data, uint32_t size);

#if ENABLE_CRC32
uint32_t kdp_gen_crc32(uint8_t *data, uint32_t size); // copy from kneron_plus\src\kneron_nef_reader.c
#endif

#endif
